////////////////////////////
//Craftsmen debuffs system//
////////////////////////////
// Amad (ID 10716)
// v1 - build 13

//!!!
function CDSdebug(%msg)
{
	if(!$CDS::debug)
	{
		return;
	}
	messageAll('', "<color:40FF40>CDS<color:FFFFFF>: " @ %msg);
	echo("CDS: " @ %msg);
}
function reload_cds()
{
	discoverfile("Add-Ons/Craftsmen_Debuffs.zip");
	exec("Add-Ons/Craftsmen_Debuffs/server.cs");
}

//CONTENTS
//	#0.0 prerequisites
//	#1.0 package
//	#2.0 stun
//		#2.1 unstun
//	#3.0 root
//		#3.1 unroot
//	#4.0 disarm
//		#4.1 undisarm
//	#5.0 silence
//		#5.1 unsilence
//	#6.0 diminishing returns

//	#0.0
if(!isObject(PlayerNoMoveArmor))
{
	datablock PlayerData(PlayerNoMoveArmor : PlayerStandardArmor)
	{
		airControl = 0;
		jumpForce = 0;
		runForce = 0;
		maxForwardSpeed = 0;
		maxSideSpeed = 0;
		maxBackwardSpeed = 0;
		maxForwardCrouchSpeed = 0;
		maxSideCrouchSpeed = 0;
		maxBackwardCrouchSpeed = 0;
		jumpSound = "";
		canRide = false;
		canJet = false;
		cameraDefaultFov = 90;
		cameraMaxFov = 90;
		cameraMinFov = 90;
		uiName = "";
	};
}

if(!isPackage(AltDatablocks))
{
	exec("./Support_AltDatablock.cs");
}

//	#1.0
package CraftsmenDebuffs
{
	function armor::damage(%this, %obj, %sourceObject, %pos, %amt, %type)
	{
		if(%obj.softstun)
		{
			%obj.unstun();
		}
		parent::damage(%this, %obj, %sourceObject, %pos, %amt, %type);
	}
	function armor::onDisabled(%this, %obj)
	{
		%obj.unstun();
		cancel(%obj.unstunSched);
		//%obj.unroot();
		cancel(%obj.unrootSched);
		if(isObject(%client = %obj.getControllingClient()))
		{
			cancel(%client.CDSprintsched);
		}
		return parent::onDisabled(%this, %obj);
	}
	function armor::onTrigger(%this, %obj, %slot, %val)
	{
		if(%obj.stunned)
		{
			return;
		}
		if(%obj.silenced && isObject(%img = %obj.getMountedImage(%slot)) && strPos(%img.getName(), "Magic") != -1)
		{
			return;
		}
		else return parent::onTrigger(%this, %obj, %slot, %val);
	}
	function player::mountImage(%this, %image, %slot)
	{
		if(%obj.disarmed && isObject(%image) && strPos(%image.getName(), "Magic") != -1)
		{
			return;
		}
		if(%obj.stunned && (%slot == 0 || %slot == 1))
		{
			return;
		}
		return parent::mountImage(%this, %image, %slot);
	}
	function player::unmountImage(%this, %slot)
	{
		if(%obj.stunned && (%slot == 0 || %slot == 1))
		{
			return;
		}
		return parent::unmountImage(%this, %slot);
	}
	function observer::onTrigger(%this, %obj, %slot, %val)
	{
		if(%this.client.player.stunned)
		{
			return;
		}
		return parent::onTrigger(%this, %obj, %slot, %val);
	}
};
activatePackage(CraftsmenDebuffs);

//	#2.0

function player::stun(%this, %duration, %soft, %dr, %customDRcat)
{
	//!!!
	CDSdebug("STUN " @ %this SPC %soft SPC %dr SPC %customDRcat);
	CDSdebug("STUN DR COUNT: " @ %this.DR[%customDRcat !$= "" ? %customDRcat : "stun"]);

	%DRcat = %customDRcat !$= "" ? %customDRcat : "stun";
	%this.softstun = %soft; //stun breaks with damage (an incapacitate)?
	if(%dr !$= "0")
	{
		if(%this.DR[%DRcat] > 2)
		{
			return; //no effect.
		}
		switch(%this.DR[%DRcat])
		{
			case 0: %mult = 1000;
			case 1: %mult = 500;
			case 2: %mult = 250;
			default: CDSdebug("DR count error: " @ %this.DR[%DRcat]);
		}
		%this.DRinc(%DRcat, %duration * %mult);
		cancel(%this.unstunSched);
		%this.unstunSched = %this.schedule(%duration * %mult, unstun);
		%this.stun_activate(%duration * %mult);
	}
	else
	{
		cancel(%this.unstunSched);
		%this.unstunSched = %this.schedule(%duration * 1000, unstun);
		%this.stun_activate(%duration * 1000);
	}
}

function player::stun_activate(%this, %duration)
{
	%this.stunned = 1;
	%this.pushDatablock(PlayerNoMoveArmor.getID());
	%this.setVelocity(setWord(setWord(%this.getVelocity(), 0, 0), 1, 0));
	if(isObject(%client = %this.client) && %client.getClassName() $= "GameConnection")
	{
		if(%client.getControlObject() == %this)
		{
			%client.camera.setMode("Corpse", %this);
			%client.setControlObject(%client.camera);
		}
		cancel(%client.CDSprintsched);
		%client.CDStext(%duration, "Stunned!");
	}
}

//todo: move this (lol)
function GameConnection::CDStext(%this, %duration, %text)
{
	cancel(%this.CDSprintsched);
	if(%duration <= 0)
	{
		%this.centerPrint(" ", 1);
		return;
	}
	%this.centerPrint("<color:FF0000>" @ %text NL mFloatLength(%duration / 1000, 1), 1);
	%this.CDSprintsched = %this.schedule(100, CDStext, %duration - 100, %text);
}

//	#2.1
function player::unstun(%this)
{
	//!!!
	CDSdebug("UNSTUN " @ %this);
	%this.stunned = 0;
	%this.popDatablock(PlayerNoMoveArmor.getID());
	if(isObject(%client = %this.client) && %client.getClassName() $= "GameConnection")
	{
		%client.camera.setFlyMode();
		%client.setControlObject(%this);
	}
}

//	#6.0
function player::DRinc(%this, %category, %durAdd)
{
	%this.DR[%category]++;
	if(!isEventPending(%this.DRtimeout[%category]))
	{
		%this.DRtimeout[%category] = %this.schedule(15000 + %durAdd, DRclear, %category);
	}
}

function player::DRclear(%this, %category)
{
	//!!!
	CDSdebug("DR CLEAR: " @ %this SPC %category);

	%this.DR[%category] = 0;
}